import sys
sys.path.insert(1, '../../')

from TextPart.textalinea import textalinea
from TextPart.masterrule import texttype
from TextPart.enum_type import enum_type

def hardcodedalineas_Plan_Velo_FR_page5() -> list[textalinea]:
    """
    This code holds the content of the textalineas-array in the textsplitter-class
    for the document Plan_Velo_FR_page5
    It is generated with the printcode()-functions of textsplitter & textalinea
    and it is supposed to be used only after a complete document analysis
    the outcome of this analysis (this script) can then be efficiently used
    for running regression-tests in the future.

    # Parameters: None (everything is hardcoded)
    # Return: list[textalinea] the hardcoded textalineas-array.
    """

    alineas = []

    thisalinea = textalinea()
    thisalinea.textlevel = 0
    thisalinea.texttitle = "Plan_Velo_FR_page5"
    thisalinea.nativeID = 0
    thisalinea.parentID = -1
    thisalinea.alineatype = texttype.TITLE
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 0
    thisalinea.summary = "Atteindre la neutralité carbone à l’horizon 2050 implique de poursuivre et d’accentuer la réduc- tion des gaz à effet de serre sur l’ensemble du territoire national. Si nous sommes sur la bonne voie, cet objectif demande chaque jour des efforts supplémentaires et nécessite de trans- former nos modes de vie, de consommation et de production. Il suppose aussi de révolutionner le secteur des transports et de décarboner nos mobilités. Dès 2018 avec la loi d’orientation des mobilités (LOM) puis le Plan vélo et mobilités actives, le Gouvernement a amorcé un travail pour faire du vélo un moyen de transport à "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 1
    thisalinea.texttitle = "LE VÉLO ET LA MARCHE : DES MOBILITÉS D’AVENIR"
    thisalinea.nativeID = 1
    thisalinea.parentID = 0
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 0
    thisalinea.summary = "Atteindre la neutralité carbone à l’horizon 2050 implique de poursuivre et d’accentuer la réduc- tion des gaz à effet de serre sur l’ensemble du territoire national. Si nous sommes sur la bonne voie, cet objectif demande chaque jour des efforts supplémentaires et nécessite de trans- former nos modes de vie, de consommation et de production. Il suppose aussi de révolutionner le secteur des transports et de décarboner nos mobilités. Dès 2018 avec la loi d’orientation des mobilités (LOM) puis le Plan vélo et mobilités actives, le Gouvernement a amorcé un travail pour faire du vélo un moyen de transport à "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("Atteindre la neutralité carbone à l’horizon 2050")
    thisalinea.textcontent.append("implique de poursuivre et d’accentuer la réduc-")
    thisalinea.textcontent.append("tion des gaz à effet de serre sur l’ensemble du")
    thisalinea.textcontent.append("territoire national. Si nous sommes sur la bonne")
    thisalinea.textcontent.append("voie, cet objectif demande chaque jour des")
    thisalinea.textcontent.append("efforts supplémentaires et nécessite de trans-")
    thisalinea.textcontent.append("former nos modes de vie, de consommation et")
    thisalinea.textcontent.append("de production. Il suppose aussi de révolutionner")
    thisalinea.textcontent.append("le secteur des transports et de décarboner nos")
    thisalinea.textcontent.append("mobilités.")
    thisalinea.textcontent.append("Dès 2018 avec la loi d’orientation des mobilités")
    thisalinea.textcontent.append("(LOM) puis le Plan vélo et mobilités actives, le")
    thisalinea.textcontent.append("Gouvernement a amorcé un travail pour faire")
    thisalinea.textcontent.append("du vélo un moyen de transport à part entière")
    thisalinea.textcontent.append("pour les déplacements du quotidien.")
    thisalinea.textcontent.append("4 ans plus tard, les résultats sont là et nous")
    thisalinea.textcontent.append("voulons redoubler d’efforts pour continuer à")
    thisalinea.textcontent.append("rendre le vélo accessible à chaque Français, en")
    thisalinea.textcontent.append("ville comme dans tous les territoires.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "• 410 millions d’euros"
    thisalinea.nativeID = 2
    thisalinea.parentID = 1
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 0
    thisalinea.summary = "c’est le montant investi dans le fonds mo- bilités actives pour accélérer les projets de création de pistes cyclables et des places de stationnement sécurisées pour les vélos dans toutes les gares. "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("c’est le montant investi dans le fonds mo-")
    thisalinea.textcontent.append("bilités actives pour accélérer les projets de")
    thisalinea.textcontent.append("création de pistes cyclables et des places de")
    thisalinea.textcontent.append("stationnement sécurisées pour les vélos dans")
    thisalinea.textcontent.append("toutes les gares.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "• 28 000 km"
    thisalinea.nativeID = 3
    thisalinea.parentID = 1
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 1
    thisalinea.summary = "c’est la longueur total des aménagements cyclables qui ont été créés, dont 17 000 km de pistes et de voies vertes sur l’ensemble du territoire (+40 % depuis 2017). "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("c’est la longueur total des aménagements")
    thisalinea.textcontent.append("cyclables qui ont été créés, dont 17 000 km")
    thisalinea.textcontent.append("de pistes et de voies vertes sur l’ensemble du")
    thisalinea.textcontent.append("territoire (+40 % depuis 2017).")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "• 4 millions"
    thisalinea.nativeID = 4
    thisalinea.parentID = 1
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 2
    thisalinea.summary = "c’est le nombre de vélos qui ont été inscrits dans le nouveau registre national d’immatri- culation, grâce au marquage obligatoire des vélos qui permet de lutter contre le vol et de restituer les vélos à leurs propriétaires lors- qu’ils sont retrouvés. • 200 000 c’est le nombre d’enfants autonomes sur la route, formés depuis 2019 grâce au pro- gramme Savoir rouler à vélo. Il permet à tous les enfants entrant au collège de maîtriser la pratique du vélo. "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("c’est le nombre de vélos qui ont été inscrits")
    thisalinea.textcontent.append("dans le nouveau registre national d’immatri-")
    thisalinea.textcontent.append("culation, grâce au marquage obligatoire des")
    thisalinea.textcontent.append("vélos qui permet de lutter contre le vol et de")
    thisalinea.textcontent.append("restituer les vélos à leurs propriétaires lors-")
    thisalinea.textcontent.append("qu’ils sont retrouvés.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 3
    thisalinea.texttitle = "• 200 000 "
    thisalinea.nativeID = 5
    thisalinea.parentID = 4
    thisalinea.alineatype = texttype.ENUMERATION
    thisalinea.enumtype = enum_type.SIGNMARK
    thisalinea.horizontal_ordering = 0
    thisalinea.summary = "• 200 000 c’est le nombre d’enfants autonomes sur la route, formés depuis 2019 grâce au pro- gramme Savoir rouler à vélo. Il permet à tous les enfants entrant au collège de maîtriser la pratique du vélo. "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("• 200 000")
    thisalinea.textcontent.append("c’est le nombre d’enfants autonomes sur")
    thisalinea.textcontent.append("la route, formés depuis 2019 grâce au pro-")
    thisalinea.textcontent.append("gramme Savoir rouler à vélo. Il permet à tous")
    thisalinea.textcontent.append("les enfants entrant au collège de maîtriser la")
    thisalinea.textcontent.append("pratique du vélo.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "• 65 millions d’euros"
    thisalinea.nativeID = 6
    thisalinea.parentID = 1
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 3
    thisalinea.summary = "c’est le montant d’aides versées à l’achat de vélos électriques, pour soutenir les ventes et la transition vers des mobilités propres. Le Plan vélo et mobilités actives a ainsi permis d’instaurer une véritable culture du vélo et d’en faire un mode de déplacement à part entière : "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("c’est le montant d’aides versées à l’achat de")
    thisalinea.textcontent.append("vélos électriques, pour soutenir les ventes et")
    thisalinea.textcontent.append("la transition vers des mobilités propres.")
    thisalinea.textcontent.append("Le Plan vélo et mobilités actives a ainsi permis")
    thisalinea.textcontent.append("d’instaurer une véritable culture du vélo et d’en")
    thisalinea.textcontent.append("faire un mode de déplacement à part entière :")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "• 52%"
    thisalinea.nativeID = 7
    thisalinea.parentID = 1
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 4
    thisalinea.summary = "c’est l’augmentation de la fréquentation des itinéraires à vélos par rapport à 2017 ; "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("c’est l’augmentation de la fréquentation des")
    thisalinea.textcontent.append("itinéraires à vélos par rapport à 2017 ;")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "• 17 millions"
    thisalinea.nativeID = 8
    thisalinea.parentID = 1
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 5
    thisalinea.summary = "c’est le nombre de vélos vendus depuis 2017, dont 2,9 millions à assistance électrique. Depuis le lancement du Plan vélo et marche, la dynamique en faveur du vélo est donc très po- sitive et reçoit l’adhésion d’un nombre croissant de Français. Pour accélérer ses effets tant sur le plan écono- mique, social, qu’environnemental, la Première ministre a lancé en septembre 2022 un acte II du plan, dédié à la période 2023-2027. À cette occasion, elle a annoncé un nouveau fonds pour le vélo, doté de 250 millions d’euros en 2023 et le lancement d’un comité interministériel. "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("c’est le nombre de vélos vendus depuis 2017,")
    thisalinea.textcontent.append("dont 2,9 millions à assistance électrique.")
    thisalinea.textcontent.append("Depuis le lancement du Plan vélo et marche, la")
    thisalinea.textcontent.append("dynamique en faveur du vélo est donc très po-")
    thisalinea.textcontent.append("sitive et reçoit l’adhésion d’un nombre croissant")
    thisalinea.textcontent.append("de Français.")
    thisalinea.textcontent.append("Pour accélérer ses effets tant sur le plan écono-")
    thisalinea.textcontent.append("mique, social, qu’environnemental, la Première")
    thisalinea.textcontent.append("ministre a lancé en septembre 2022 un acte II")
    thisalinea.textcontent.append("du plan, dédié à la période 2023-2027. À cette")
    thisalinea.textcontent.append("occasion, elle a annoncé un nouveau fonds pour")
    thisalinea.textcontent.append("le vélo, doté de 250 millions d’euros en 2023 et")
    thisalinea.textcontent.append("le lancement d’un comité interministériel.")
    thisalinea.textcontent.append("")
    alineas.append(thisalinea)

    return alineas
