import sys
# caution: path[0] is reserved for script path (or '' in REPL)

# Imports from TextPart code:
sys.path.insert(1, '../../')
from TextPart.lineregion import lineregion

def hardcodedlineregions_pdfminer_LineTest1() -> list[lineregion]:
    """
    This function provides some hard-coded lineregions
    for the purpose of unit-tests
    
    # Parameters: None
    # Returns: those lineregions.
    """
    
    # -------------------------------------------------------
    
    trueregions = []
    
    thisregion = lineregion()
    thisregion.set_left(-3.9506498390399987)
    thisregion.set_right(-1.4137250486400024)
    thisregion.set_value(-1.9573517894400017)
    thisregion.set_frequency(0.031446540880503145)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(False)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(-1.4137250486400024)
    thisregion.set_right(5.291004754559988)
    thisregion.set_value(-0.8700983078400031)
    thisregion.set_frequency(0.006289308176100629)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(True)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(5.291004754559988)
    thisregion.set_right(12.539361298559978)
    thisregion.set_value(11.452107816959979)
    thisregion.set_frequency(0.15723270440251572)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(12.539361298559978)
    thisregion.set_right(16.70716631135997)
    thisregion.set_value(13.626614780159976)
    thisregion.set_frequency(0.6729559748427673)
    thisregion.set_isregular(True)
    thisregion.set_issmall(False)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(16.70716631135997)
    thisregion.set_right(20.15013566975997)
    thisregion.set_value(19.787717842559967)
    thisregion.set_frequency(0.08176100628930819)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(20.15013566975997)
    thisregion.set_right(21.599806978559965)
    thisregion.set_value(20.512553496959967)
    thisregion.set_frequency(0.006289308176100629)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(21.599806978559965)
    thisregion.set_right(24.13673176895996)
    thisregion.set_value(22.687060460159962)
    thisregion.set_frequency(0.006289308176100629)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(24.13673176895996)
    thisregion.set_right(27.217283300159956)
    thisregion.set_value(25.586403077759957)
    thisregion.set_frequency(0.012578616352201259)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(27.217283300159956)
    thisregion.set_right(30.297834831359953)
    thisregion.set_value(28.848163522559954)
    thisregion.set_frequency(0.006289308176100629)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(30.297834831359953)
    thisregion.set_right(100000.0)
    thisregion.set_value(31.747506140159953)
    thisregion.set_frequency(0.01886792452830189)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    return trueregions

def hardcodedlineregions_pymupdf_LineTest1() -> list[lineregion]:
    """
    This function provides some hard-coded lineregions
    for the purpose of unit-tests
    
    # Parameters: None
    # Returns: those lineregions.
    """
    
    # -------------------------------------------------------
    
    trueregions = []

    thisregion = lineregion()
    thisregion.set_left(-4.006945831805429)
    thisregion.set_right(-1.510159164385973)
    thisregion.set_value(-2.045184878832999)
    thisregion.set_frequency(0.04888888888888889)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(False)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(-1.510159164385973)
    thisregion.set_right(-0.44010773549192095)
    thisregion.set_value(-0.975133449938947)
    thisregion.set_frequency(0.008888888888888889)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(False)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(-0.44010773549192095)
    thisregion.set_right(1.878337027111859)
    thisregion.set_value(0.09491797895510515)
    thisregion.set_frequency(0.23555555555555557)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(True)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(1.878337027111859)
    thisregion.set_right(4.196781789715639)
    thisregion.set_value(3.6617560752686127)
    thisregion.set_frequency(0.0044444444444444444)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(4.196781789715639)
    thisregion.set_right(5.088491313794017)
    thisregion.set_value(4.731807504162666)
    thisregion.set_frequency(0.008888888888888889)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(5.088491313794017)
    thisregion.set_right(8.476987505291849)
    thisregion.set_value(5.445175123425368)
    thisregion.set_frequency(0.013333333333333334)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(8.476987505291849)
    thisregion.set_right(12.043825601605356)
    thisregion.set_value(11.50879988715833)
    thisregion.set_frequency(0.1111111111111111)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(12.043825601605356)
    thisregion.set_right(13.11387703049941)
    thisregion.set_value(12.578851316052383)
    thisregion.set_frequency(0.0044444444444444444)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(13.11387703049941)
    thisregion.set_right(16.50237322199724)
    thisregion.set_value(13.648902744946437)
    thisregion.set_frequency(0.4711111111111111)
    thisregion.set_isregular(True)
    thisregion.set_issmall(False)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(16.50237322199724)
    thisregion.set_right(20.960920842389122)
    thisregion.set_value(19.355843699048044)
    thisregion.set_frequency(0.05777777777777778)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(20.960920842389122)
    thisregion.set_right(23.814391319439927)
    thisregion.set_value(22.565997985730203)
    thisregion.set_frequency(0.0044444444444444444)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(23.814391319439927)
    thisregion.set_right(25.419468462781005)
    thisregion.set_value(25.062784653149656)
    thisregion.set_frequency(0.0044444444444444444)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(25.419468462781005)
    thisregion.set_right(28.45128084464749)
    thisregion.set_value(25.776152272412357)
    thisregion.set_frequency(0.008888888888888889)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(28.45128084464749)
    thisregion.set_right(31.483093226513972)
    thisregion.set_value(31.12640941688262)
    thisregion.set_frequency(0.0044444444444444444)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(31.483093226513972)
    thisregion.set_right(100000.0)
    thisregion.set_value(31.839777036145325)
    thisregion.set_frequency(0.013333333333333334)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    return trueregions

def hardcodedlineregions_pdfminer_LineTest2() -> list[lineregion]:
    """
    This function provides some hard-coded lineregions
    for the purpose of unit-tests
    
    # Parameters: None
    # Returns: those lineregions.
    """
    
    # -------------------------------------------------------
    
    trueregions = []

    thisregion = lineregion()
    thisregion.set_left(-4.5924167126123745)
    thisregion.set_right(-1.4900244795937154)
    thisregion.set_value(-2.054095794688017)
    thisregion.set_frequency(0.09219858156028368)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(False)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(-1.4900244795937154)
    thisregion.set_right(-0.3618818494051126)
    thisregion.set_value(-0.9259531644994141)
    thisregion.set_frequency(0.0070921985815602835)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(False)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(-0.3618818494051126)
    thisregion.set_right(6.124938274179356)
    thisregion.set_value(0.20218946568918894)
    thisregion.set_frequency(0.0070921985815602835)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(True)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(6.124938274179356)
    thisregion.set_right(12.611758397763824)
    thisregion.set_value(12.047687082669523)
    thisregion.set_frequency(0.07801418439716312)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(12.611758397763824)
    thisregion.set_right(15.43211497323533)
    thisregion.set_value(13.175829712858125)
    thisregion.set_frequency(0.02127659574468085)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(15.43211497323533)
    thisregion.set_right(19.09857852134829)
    thisregion.set_value(17.688400233612537)
    thisregion.set_frequency(0.035460992907801414)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(19.09857852134829)
    thisregion.set_right(22.20097075436695)
    thisregion.set_value(20.508756809084044)
    thisregion.set_frequency(0.5886524822695035)
    thisregion.set_isregular(True)
    thisregion.set_issmall(False)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(22.20097075436695)
    thisregion.set_right(25.021327329838456)
    thisregion.set_value(23.893184699649854)
    thisregion.set_frequency(0.0070921985815602835)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(25.021327329838456)
    thisregion.set_right(29.533897850592865)
    thisregion.set_value(26.14946996002706)
    thisregion.set_frequency(0.0070921985815602835)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(29.533897850592865)
    thisregion.set_right(34.32850402889443)
    thisregion.set_value(32.918325741158675)
    thisregion.set_frequency(0.10638297872340426)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(34.32850402889443)
    thisregion.set_right(36.302753631724485)
    thisregion.set_value(35.73868231663018)
    thisregion.set_frequency(0.014184397163120567)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(36.302753631724485)
    thisregion.set_right(38.84107454964884)
    thisregion.set_value(36.86682494681878)
    thisregion.set_frequency(0.0070921985815602835)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(38.84107454964884)
    thisregion.set_right(42.78957375530895)
    thisregion.set_value(40.815324152478894)
    thisregion.set_frequency(0.0070921985815602835)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(42.78957375530895)
    thisregion.set_right(46.45603730342191)
    thisregion.set_value(44.76382335813901)
    thisregion.set_frequency(0.014184397163120567)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(46.45603730342191)
    thisregion.set_right(100000.0)
    thisregion.set_value(48.14825124870482)
    thisregion.set_frequency(0.0070921985815602835)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)
    
    return trueregions

def hardcodedlineregions_pymupdf_LineTest2() -> list[lineregion]:
    """
    This function provides some hard-coded lineregions
    for the purpose of unit-tests
    
    # Parameters: None
    # Returns: those lineregions.
    """
    
    # -------------------------------------------------------
    
    trueregions = []

    thisregion = lineregion()
    thisregion.set_left(-4.448935391363526)
    thisregion.set_right(-1.7226490628768918)
    thisregion.set_value(-2.2183374862380982)
    thisregion.set_frequency(0.1724137931034483)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(False)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(-1.7226490628768918)
    thisregion.set_right(-0.7312722161544787)
    thisregion.set_value(-1.2269606395156851)
    thisregion.set_frequency(0.004310344827586207)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(False)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(-0.7312722161544787)
    thisregion.set_right(0.5079488422485372)
    thisregion.set_value(-0.23558379279327227)
    thisregion.set_frequency(0.19827586206896552)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(True)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(0.5079488422485372)
    thisregion.set_right(2.986390959054569)
    thisregion.set_value(1.2514814772903466)
    thisregion.set_frequency(0.008620689655172414)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(2.986390959054569)
    thisregion.set_right(8.191119404347235)
    thisregion.set_value(4.7213004408187915)
    thisregion.set_frequency(0.004310344827586207)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(8.191119404347235)
    thisregion.set_right(12.40447100291749)
    thisregion.set_value(11.66093836787568)
    thisregion.set_frequency(0.1206896551724138)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(12.40447100291749)
    thisregion.set_right(14.387224696362315)
    thisregion.set_value(13.148003637959299)
    thisregion.set_frequency(0.017241379310344827)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(14.387224696362315)
    thisregion.set_right(16.12213417812654)
    thisregion.set_value(15.626445754765331)
    thisregion.set_frequency(0.004310344827586207)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(16.12213417812654)
    thisregion.set_right(17.113511024848954)
    thisregion.set_value(16.61782260148775)
    thisregion.set_frequency(0.008620689655172414)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(17.113511024848954)
    thisregion.set_right(18.600576294932573)
    thisregion.set_value(17.60919944821016)
    thisregion.set_frequency(0.01293103448275862)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(18.600576294932573)
    thisregion.set_right(26.531591068711876)
    thisregion.set_value(20.583329988377397)
    thisregion.set_frequency(0.3620689655172413)
    thisregion.set_isregular(True)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(26.531591068711876)
    thisregion.set_right(36.445359535936)
    thisregion.set_value(32.47985214904635)
    thisregion.set_frequency(0.06465517241379311)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(36.445359535936)
    thisregion.set_right(42.14577640458987)
    thisregion.set_value(40.41086692282565)
    thisregion.set_frequency(0.008620689655172414)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(42.14577640458987)
    thisregion.set_right(44.3763743097153)
    thisregion.set_value(43.880685886354094)
    thisregion.set_frequency(0.004310344827586207)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(44.3763743097153)
    thisregion.set_right(100000.0)
    thisregion.set_value(44.87206273307651)
    thisregion.set_frequency(0.008620689655172414)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)
    
    return trueregions

def hardcodedlineregions_pdfminer_SplitDoc() -> list[lineregion]:
    """
    This function provides some hard-coded lineregions
    for the purpose of unit-tests
    
    # Parameters: None
    # Returns: those lineregions.
    """
    
    # -------------------------------------------------------
    
    trueregions = []
    
    thisregion = lineregion()
    thisregion.set_left(-3.8517408990528095)
    thisregion.set_right(-1.520660543750383)
    thisregion.set_value(-1.9577381103695881)
    thisregion.set_frequency(0.23076923076923078)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(False)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(-1.520660543750383)
    thisregion.set_right(-0.5008128883055714)
    thisregion.set_value(-1.083582977131178)
    thisregion.set_frequency(0.038461538461538464)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(False)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(-0.5008128883055714)
    thisregion.set_right(6.0553506109825035)
    thisregion.set_value(0.08195720052003536)
    thisregion.set_frequency(0.07692307692307693)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(True)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(6.0553506109825035)
    thisregion.set_right(16.836597254256226)
    thisregion.set_value(12.028744021444972)
    thisregion.set_frequency(0.38461538461538464)
    thisregion.set_isregular(True)
    thisregion.set_issmall(False)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(16.836597254256226)
    thisregion.set_right(22.081528053686686)
    thisregion.set_value(21.64445048706748)
    thisregion.set_frequency(0.07692307692307693)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(22.081528053686686)
    thisregion.set_right(100000.0)
    thisregion.set_value(22.51860562030589)
    thisregion.set_frequency(0.19230769230769232)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)
    
    return trueregions

def hardcodedlineregions_pdfminer_TestTex() -> list[lineregion]:
    """
    This function provides some hard-coded lineregions
    for the purpose of unit-tests
    
    # Parameters: None
    # Returns: those lineregions.
    """
    
    # -------------------------------------------------------

    trueregions = []
    
    thisregion = lineregion()
    thisregion.set_left(-3.9167720567443225)
    thisregion.set_right(-1.457494634684156)
    thisregion.set_value(-1.8358450073087969)
    thisregion.set_frequency(0.13636363636363635)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(False)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(-1.457494634684156)
    thisregion.set_right(-0.5116187031225534)
    thisregion.set_value(-1.079144262059515)
    thisregion.set_frequency(0.045454545454545456)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(False)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(-0.5116187031225534)
    thisregion.set_right(5.920337631496344)
    thisregion.set_value(0.055906855814408185)
    thisregion.set_frequency(0.09090909090909091)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(True)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(5.920337631496344)
    thisregion.set_right(12.919819525052203)
    thisregion.set_value(11.78476840717828)
    thisregion.set_frequency(0.22727272727272727)
    thisregion.set_isregular(True)
    thisregion.set_issmall(False)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(12.919819525052203)
    thisregion.set_right(15.94662250604933)
    thisregion.set_value(14.054870642926126)
    thisregion.set_frequency(0.045454545454545456)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(15.94662250604933)
    thisregion.set_right(19.351775859671097)
    thisregion.set_value(17.838374369172534)
    thisregion.set_frequency(0.045454545454545456)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(19.351775859671097)
    thisregion.set_right(21.432702909106624)
    thisregion.set_value(20.86517735016966)
    thisregion.set_frequency(0.13636363636363635)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(21.432702909106624)
    thisregion.set_right(25.216206635353036)
    thisregion.set_value(22.000228468043588)
    thisregion.set_frequency(0.045454545454545456)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(25.216206635353036)
    thisregion.set_right(31.080637411034967)
    thisregion.set_value(28.432184802662483)
    thisregion.set_frequency(0.09090909090909091)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(31.080637411034967)
    thisregion.set_right(100000.0)
    thisregion.set_value(33.72909001940745)
    thisregion.set_frequency(0.13636363636363635)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)
    
    return trueregions
    
def hardcodedlineregions_pymupdf_SplitDoc() -> list[lineregion]:
    """
    This function provides some hard-coded lineregions
    for the purpose of unit-tests
    
    # Parameters: None
    # Returns: those lineregions.
    """
    
    # -------------------------------------------------------
    
    trueregions = []
    
    thisregion = lineregion()
    thisregion.set_left(-4.40989223419189)
    thisregion.set_right(-2.721731795883179)
    thisregion.set_value(-3.204063349685668)
    thisregion.set_frequency(0.02040816326530612)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(False)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(-2.721731795883179)
    thisregion.set_right(-1.7570686882782014)
    thisregion.set_value(-2.2394002420806904)
    thisregion.set_frequency(0.12244897959183673)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(False)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(-1.7570686882782014)
    thisregion.set_right(-0.5512398037719792)
    thisregion.set_value(-1.2747371344757126)
    thisregion.set_frequency(0.04081632653061224)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(False)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(-0.5512398037719792)
    thisregion.set_right(2.3427495190429544)
    thisregion.set_value(0.17225752693175403)
    thisregion.set_frequency(0.30612244897959184)
    thisregion.set_isregular(True)
    thisregion.set_issmall(False)
    thisregion.set_isbig(False)
    thisregion.set_iszero(True)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(2.3427495190429544)
    thisregion.set_right(7.648396610870332)
    thisregion.set_value(4.513241511154154)
    thisregion.set_frequency(0.02040816326530612)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(7.648396610870332)
    thisregion.set_right(11.265883264388998)
    thisregion.set_value(10.78355171058651)
    thisregion.set_frequency(0.02040816326530612)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(11.265883264388998)
    thisregion.set_right(16.81269613311762)
    thisregion.set_value(11.748214818191487)
    thisregion.set_frequency(0.1836734693877551)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(16.81269613311762)
    thisregion.set_right(22.600674778747486)
    thisregion.set_value(21.877177448043753)
    thisregion.set_frequency(0.02040816326530612)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(22.600674778747486)
    thisregion.set_right(25.012332547759932)
    thisregion.set_value(23.32417210945122)
    thisregion.set_frequency(0.02040816326530612)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(25.012332547759932)
    thisregion.set_right(28.388653424377353)
    thisregion.set_value(26.700492986068642)
    thisregion.set_frequency(0.12244897959183673)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(28.388653424377353)
    thisregion.set_right(34.90012940071095)
    thisregion.set_value(30.076813862686066)
    thisregion.set_frequency(0.02040816326530612)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(34.90012940071095)
    thisregion.set_right(100000.0)
    thisregion.set_value(39.723444938735845)
    thisregion.set_frequency(0.10204081632653061)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)
    
    return trueregions

def hardcodedlineregions_pymupdf_TestTex() -> list[lineregion]:
    """
    This function provides some hard-coded lineregions
    for the purpose of unit-tests
    
    # Parameters: None
    # Returns: those lineregions.
    """
    
    # -------------------------------------------------------

    trueregions = []
    
    thisregion = lineregion()
    thisregion.set_left(-4.184228465332033)
    thisregion.set_right(-1.55087832531738)
    thisregion.set_value(-1.956009116088865)
    thisregion.set_frequency(0.08333333333333333)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(False)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(-1.55087832531738)
    thisregion.set_right(-0.5380513483886669)
    thisregion.set_value(-1.1457475345458947)
    thisregion.set_frequency(0.027777777777777776)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(False)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(-0.5380513483886669)
    thisregion.set_right(5.944041303955095)
    thisregion.set_value(0.0696448377685609)
    thisregion.set_frequency(0.4444444444444444)
    thisregion.set_isregular(True)
    thisregion.set_issmall(False)
    thisregion.set_isbig(False)
    thisregion.set_iszero(True)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(5.944041303955095)
    thisregion.set_right(12.831264747070342)
    thisregion.set_value(11.81843777014163)
    thisregion.set_frequency(0.1388888888888889)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(12.831264747070342)
    thisregion.set_right(16.882572654785193)
    thisregion.set_value(13.844091723999057)
    thisregion.set_frequency(0.027777777777777776)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(16.882572654785193)
    thisregion.set_right(20.933880562500047)
    thisregion.set_value(19.921053585571332)
    thisregion.set_frequency(0.027777777777777776)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(20.933880562500047)
    thisregion.set_right(23.5672307025147)
    thisregion.set_value(21.94670753942876)
    thisregion.set_frequency(0.027777777777777776)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(23.5672307025147)
    thisregion.set_right(25.795450051757868)
    thisregion.set_value(25.18775386560064)
    thisregion.set_frequency(0.08333333333333333)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(25.795450051757868)
    thisregion.set_right(27.41597321484381)
    thisregion.set_value(26.403146237915095)
    thisregion.set_frequency(0.027777777777777776)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(27.41597321484381)
    thisregion.set_right(29.03649637792975)
    thisregion.set_value(28.428800191772524)
    thisregion.set_frequency(0.027777777777777776)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(29.03649637792975)
    thisregion.set_right(100000.0)
    thisregion.set_value(29.64419256408698)
    thisregion.set_frequency(0.08333333333333333)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)
    
    return trueregions

def hardcodedlineregions_pdfminer_LineTest1_endpeaks() -> list[lineregion]:
    """
    This function provides some hard-coded lineregions
    for the purpose of unit-tests
    
    # Parameters: None
    # Returns: those lineregions.
    """
    
    # -------------------------------------------------------
    
    trueregions = []

    thisregion = lineregion()
    thisregion.set_left(-3.9506498372)
    thisregion.set_right(-2.6821874414)
    thisregion.set_value(-3.4070230964)
    thisregion.set_frequency(0.06593406593406594)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(False)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(-2.6821874414)
    thisregion.set_right(-1.4137250464000002)
    thisregion.set_value(-1.9573517864000003)
    thisregion.set_frequency(0.0273224043715847)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(False)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(-1.4137250464000002)
    thisregion.set_right(5.291004753600001)
    thisregion.set_value(-0.8700983064)
    thisregion.set_frequency(0.005494505494505495)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(True)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(5.291004753600001)
    thisregion.set_right(12.539361298600001)
    thisregion.set_value(11.452107813600001)
    thisregion.set_frequency(0.13736263736263737)
    thisregion.set_isregular(False)
    thisregion.set_issmall(True)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(12.539361298600001)
    thisregion.set_right(16.7071663136)
    thisregion.set_value(13.626614783600001)
    thisregion.set_frequency(0.5846994535519126)
    thisregion.set_isregular(True)
    thisregion.set_issmall(False)
    thisregion.set_isbig(False)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(16.7071663136)
    thisregion.set_right(20.1501356686)
    thisregion.set_value(19.7877178436)
    thisregion.set_frequency(0.07142857142857142)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(20.1501356686)
    thisregion.set_right(21.5998069786)
    thisregion.set_value(20.5125534936)
    thisregion.set_frequency(0.005494505494505495)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(21.5998069786)
    thisregion.set_right(24.1367317686)
    thisregion.set_value(22.687060463599998)
    thisregion.set_frequency(0.005494505494505495)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(24.1367317686)
    thisregion.set_right(27.2172832986)
    thisregion.set_value(25.5864030736)
    thisregion.set_frequency(0.01098901098901099)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(27.2172832986)
    thisregion.set_right(30.2978348336)
    thisregion.set_value(28.8481635236)
    thisregion.set_frequency(0.005494505494505495)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(30.2978348336)
    thisregion.set_right(32.1099239686)
    thisregion.set_value(31.7475061436)
    thisregion.set_frequency(0.016483516483516484)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)

    thisregion = lineregion()
    thisregion.set_left(32.1099239686)
    thisregion.set_right(100000.0)
    thisregion.set_value(32.4723417936)
    thisregion.set_frequency(0.06593406593406594)
    thisregion.set_isregular(False)
    thisregion.set_issmall(False)
    thisregion.set_isbig(True)
    thisregion.set_iszero(False)
    thisregion.set_isvalid(True)
    trueregions.append(thisregion)
    
    return trueregions
